Index: tests/src/io/test-sink.c
===================================================================
--- tests/src/io/test-sink.c	(revision d7ac23fa5767fd3b35ff4cc8dfe7c172cd99bff2)
+++ tests/src/io/test-sink.c	(revision a5597968ec6b5b2f1614b8b56c4c759c44e7e4ac)
@@ -13,9 +13,11 @@
   }
 
+  uint_t samplerate = 0;
+  uint_t hop_size = 512;
+  uint_t n_frames = 0, read = 0;
+
   char_t *source_path = argv[1];
   char_t *sink_path = argv[2];
 
-  uint_t samplerate = 0;
-  uint_t hop_size = 256;
   if ( argc >= 4 ) samplerate = atoi(argv[3]);
   if ( argc >= 5 ) hop_size = atoi(argv[4]);
@@ -37,6 +39,4 @@
   if (!o) { err = 1; goto beach_sink; }
 
-  uint_t n_frames = 0, read = 0;
-
   do {
     aubio_source_do(i, vec, &read);
Index: tests/src/io/test-sink_apple_audio.c
===================================================================
--- tests/src/io/test-sink_apple_audio.c	(revision d7ac23fa5767fd3b35ff4cc8dfe7c172cd99bff2)
+++ tests/src/io/test-sink_apple_audio.c	(revision a5597968ec6b5b2f1614b8b56c4c759c44e7e4ac)
@@ -13,5 +13,5 @@
     err = 2;
     PRINT_ERR("not enough arguments\n");
-    PRINT_MSG("usage: %s <input_path> <output_path> [samplerate]\n", argv[0]);
+    PRINT_MSG("usage: %s <input_path> <output_path> [samplerate] [hop_size]\n", argv[0]);
     return err;
   }
@@ -24,12 +24,23 @@
   char_t *source_path = argv[1];
   char_t *sink_path = argv[2];
-  if ( argc == 4 ) samplerate = atoi(argv[3]);
+
+  if ( argc >= 4 ) samplerate = atoi(argv[3]);
+  if ( argc >= 5 ) hop_size = atoi(argv[4]);
+  if ( argc >= 6 ) {
+    err = 2;
+    PRINT_ERR("too many arguments\n");
+    return err;
+  }
 
   fvec_t *vec = new_fvec(hop_size);
+  if (!vec) { err = 1; goto beach_fvec; }
+
   aubio_source_t *i = new_aubio_source(source_path, samplerate, hop_size);
+  if (!i) { err = 1; goto beach_source; }
+
   if (samplerate == 0 ) samplerate = aubio_source_get_samplerate(i);
+
   aubio_sink_apple_audio_t *o = new_aubio_sink_apple_audio(sink_path, samplerate);
-
-  if (!i || !o) { err = 1; goto beach; }
+  if (!o) { err = 1; goto beach_sink; }
 
   do {
@@ -39,11 +50,14 @@
   } while ( read == hop_size );
 
-  PRINT_MSG("%d frames read from %s\n written to %s at %dHz\n",
-      n_frames, source_path, sink_path, samplerate);
+  PRINT_MSG("read %d frames at %dHz (%d blocks) from %s written to %s\n",
+      n_frames, samplerate, n_frames / hop_size,
+      source_path, sink_path);
 
-beach:
+  del_aubio_sink_apple_audio(o);
+beach_sink:
   del_aubio_source(i);
-  del_aubio_sink_apple_audio(o);
+beach_source:
   del_fvec(vec);
+beach_fvec:
 #else
   err = 3;
Index: tests/src/io/test-sink_sndfile.c
===================================================================
--- tests/src/io/test-sink_sndfile.c	(revision d7ac23fa5767fd3b35ff4cc8dfe7c172cd99bff2)
+++ tests/src/io/test-sink_sndfile.c	(revision a5597968ec6b5b2f1614b8b56c4c759c44e7e4ac)
@@ -14,5 +14,5 @@
     err = 2;
     PRINT_ERR("not enough arguments\n");
-    PRINT_MSG("usage: %s <input_path> <output_path> [samplerate]\n", argv[0]);
+    PRINT_MSG("usage: %s <input_path> <output_path> [samplerate] [hop_size]\n", argv[0]);
     return err;
   }
@@ -25,26 +25,40 @@
   char_t *source_path = argv[1];
   char_t *sink_path = argv[2];
-  if ( argc == 4 ) samplerate = atoi(argv[3]);
+
+  if ( argc >= 4 ) samplerate = atoi(argv[3]);
+  if ( argc >= 5 ) hop_size = atoi(argv[4]);
+  if ( argc >= 6 ) {
+    err = 2;
+    PRINT_ERR("too many arguments\n");
+    return err;
+  }
 
   fvec_t *vec = new_fvec(hop_size);
-  aubio_source_sndfile_t * i = new_aubio_source_sndfile(source_path, samplerate, hop_size);
-  if (samplerate == 0 ) samplerate = aubio_source_sndfile_get_samplerate(i);
-  aubio_sink_sndfile_t *   o = new_aubio_sink_sndfile(sink_path, samplerate);
+  if (!vec) { err = 1; goto beach_fvec; }
 
-  if (!i || !o) { err = 1; goto beach; }
+  aubio_source_t *i = new_aubio_source(source_path, samplerate, hop_size);
+  if (!i) { err = 1; goto beach_source; }
+
+  if (samplerate == 0 ) samplerate = aubio_source_get_samplerate(i);
+
+  aubio_sink_sndfile_t *o = new_aubio_sink_sndfile(sink_path, samplerate);
+  if (!o) { err = 1; goto beach_sink; }
 
   do {
-    aubio_source_sndfile_do(i, vec, &read);
+    aubio_source_do(i, vec, &read);
     aubio_sink_sndfile_do(o, vec, read);
     n_frames += read;
   } while ( read == hop_size );
 
-  PRINT_MSG("%d frames read from %s\n written to %s at %dHz\n",
-      n_frames, source_path, sink_path, samplerate);
+  PRINT_MSG("read %d frames at %dHz (%d blocks) from %s written to %s\n",
+      n_frames, samplerate, n_frames / hop_size,
+      source_path, sink_path);
 
-beach:
-  del_aubio_source_sndfile(i);
   del_aubio_sink_sndfile(o);
+beach_sink:
+  del_aubio_source(i);
+beach_source:
   del_fvec(vec);
+beach_fvec:
 #else
   err = 3;
Index: tests/src/io/test-sink_wavwrite.c
===================================================================
--- tests/src/io/test-sink_wavwrite.c	(revision d7ac23fa5767fd3b35ff4cc8dfe7c172cd99bff2)
+++ tests/src/io/test-sink_wavwrite.c	(revision a5597968ec6b5b2f1614b8b56c4c759c44e7e4ac)
@@ -13,5 +13,5 @@
     err = 2;
     PRINT_ERR("not enough arguments\n");
-    PRINT_MSG("usage: %s <input_path> <output_path> [samplerate]\n", argv[0]);
+    PRINT_MSG("usage: %s <input_path> <output_path> [samplerate] [hop_size]\n", argv[0]);
     return err;
   }
@@ -24,12 +24,23 @@
   char_t *source_path = argv[1];
   char_t *sink_path = argv[2];
-  if ( argc == 4 ) samplerate = atoi(argv[3]);
+
+  if ( argc >= 4 ) samplerate = atoi(argv[3]);
+  if ( argc >= 5 ) hop_size = atoi(argv[4]);
+  if ( argc >= 6 ) {
+    err = 2;
+    PRINT_ERR("too many arguments\n");
+    return err;
+  }
 
   fvec_t *vec = new_fvec(hop_size);
+  if (!vec) { err = 1; goto beach_fvec; }
+
   aubio_source_t *i = new_aubio_source(source_path, samplerate, hop_size);
+  if (!i) { err = 1; goto beach_source; }
+
   if (samplerate == 0 ) samplerate = aubio_source_get_samplerate(i);
+
   aubio_sink_wavwrite_t *o = new_aubio_sink_wavwrite(sink_path, samplerate);
-
-  if (!i || !o) { err = 1; goto beach; }
+  if (!o) { err = 1; goto beach_sink; }
 
   do {
@@ -39,11 +50,14 @@
   } while ( read == hop_size );
 
-  PRINT_MSG("%d frames read from %s\n written to %s at %dHz\n",
-      n_frames, source_path, sink_path, samplerate);
+  PRINT_MSG("read %d frames at %dHz (%d blocks) from %s written to %s\n",
+      n_frames, samplerate, n_frames / hop_size,
+      source_path, sink_path);
 
-beach:
+  del_aubio_sink_wavwrite(o);
+beach_sink:
   del_aubio_source(i);
-  del_aubio_sink_wavwrite(o);
+beach_source:
   del_fvec(vec);
+beach_fvec:
 #else
   err = 3;
